乐筑天下

搜索
欢迎各位开发者和用户入驻本平台 尊重版权,从我做起,拒绝盗版,拒绝倒卖 签到、发布资源、邀请好友注册,可以获得银币 请注意保管好自己的密码,避免账户资金被盗
查看: 10|回复: 0

下面程序是在wcs下生成回转体,但我想在其他ucs下生成,不知如何实现?请知教

[复制链接]

7

主题

18

帖子

1

银币

初来乍到

Rank: 1

铜币
46
发表于 2003-6-2 14:38:00 | 显示全部楼层 |阅读模式
下面程序是在wcs下生成回转体,但我想在其他ucs下生成,不知如何实现?请知教        
          double pi=3.1415926535897932384626433832795;
        int isRadio;
        AcGeVector3d normal(0.0,0.0,1.);
        isRadio=GetCheckedRadioButton(IDC_RADIO_BALL,IDC_RADIO_FACE);
        AcGePoint2dArray pt;
        pt.setLogicalLength(4);
        if(isRadio==IDC_RADIO_BALL)
                {pt[0].set(0.,0.);
                pt[1].set(m_toolradius,m_toolradius);
                pt[2].set(m_toolradius,m_toollength);
                pt[3].set(0.,m_toollength);
                AcDbPolyline *poly=new AcDbPolyline;
                double bulge=22.5/180*pi;
                bulge=tan(bulge);
                for (int i=0;iaddVertexAt(i,pt[i],(i==0)?bulge:0.0,0.0,0.0);
                        }
                poly->setClosed(true);
                poly->setNormal(normal);
                AcDbVoidPtrArray line,region;
                line.append((void *)poly);
        
                AcDbRegion::createFromCurves(line,region);
                AcDbRegion *pRegion=AcDbRegion::cast((AcRxObject *)region[0]);
                AcDb3dSolid *p3d=new AcDb3dSolid;
                AcGePoint3d axisPoint (0.,0.,0.);
                AcGeVector3d axisDir(0.,1.,0.);
                p3d->revolve(pRegion,axisPoint,axisDir,2*pi);
                AcDbObjectId id;
        
                AcGePoint3d origin(0,0,m_tooldistance);
                AcGeMatrix3d mat;
                AcGeVector3d x(1,0,0),y(0,0,1),z(0,-1,0);
                mat.setCoordSystem(origin,x,y,z);
                p3d->transformBy(mat);
                postToDatabase(p3d,id);
                delete pRegion;
                acedCommand(RTSTR,"REDRAW",0);
               
                }
回复

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

  • 微信公众平台

  • 扫描访问手机版

  • 点击图片下载手机App

QQ|关于我们|小黑屋|乐筑天下 繁体中文

GMT+8, 2024-11-22 09:08 , Processed in 0.332691 second(s), 65 queries .

© 2020-2024 乐筑天下

联系客服 关注微信 帮助中心 下载APP 返回顶部 返回列表